30天刷题挑战(二十四)

题目来源: LeetCode 75 30 天 JavaScript 挑战

2695. 包装数组

代码

js 复制代码
/**
 * @param {number[]} nums
 * @return {void}
 */
var ArrayWrapper = function(nums) {
    this.arr = nums
};

/**
 * @return {number}
 */
ArrayWrapper.prototype.valueOf = function() {
    return this.arr.reduce((cur, pre) => cur + pre, 0)
}

/**
 * @return {string}
 */
ArrayWrapper.prototype.toString = function() {
  return `[${this.arr.join(",")}]`
}

338. 比特位计数

思路

根据二进制奇偶数特性,奇数一定比前面那个偶数多一个 1; 偶数中 1 的个数一定和除以 2 之后的那个数一样多

代码

js 复制代码
/**
 * @param {number} n
 * @return {number[]}
 */
var countBits = function(n) {
  let res = Array(n + 1).fill(0)

  for(let i = 1; i <= n; i++) {
     if (i % 2 === 1) {
       res[i] = res[i - 1] + 1
     } else {
       res[i] = res[i/2]
     }

  }
  
  return res
};

136. 只出现一次的数字

思路

位运算,由于题目告诉了其他数字都出现了两次,所以使用异或算法,将相同的数字变成 0

代码

js 复制代码
/**
 * @param {number[]} nums
 * @return {number}
 */
var singleNumber = function(nums) {
  let ans = 0

  for(let n of nums) {
    ans ^= n
  }
  
  return ans
};

1318. 或运算的最小翻转次数

思路

模拟法,先声明一个变量记录操作数,如果 a 和 b 的第一位或操作不等于 c 的第一位,ab 都需要操作就加 2,否则加 1;abc 都进行右移 1 位的操作,直到三个数都为 0。

代码

js 复制代码
const minFlips = (a, b, c) => {
  let ret = 0;
  
  while (a > 0 || b > 0 || c > 0) {
    if (((a & 1) | (b & 1)) !== (c & 1)) {
      ret += (a & 1) === 1 && (b & 1) === 1 ? 2 : 1;
    }
    
    a >>>= 1;
    b >>>= 1;
    c >>>= 1;
  }
  
  return ret;
};

本文完,感谢阅读。

相关推荐
u01110267533 分钟前
图片处理接口如何统一错误信息 前端提示与后端错误码设计
前端·状态模式
好想像大佬一样能够ak所有36 分钟前
Leetcode35.搜索插入位置
数据结构·算法·leetcode
aqiu11111136 分钟前
【C++算法打怪专栏】LeetCode 165. 比较版本号(双指针与字符串流法)
c++·算法·leetcode
黄金龙PLUS43 分钟前
如何基于置换算法来设计对称加密算法
算法·网络安全·密码学·哈希算法·同态加密
不会就选b1 小时前
算法日常・每日刷题--<动态规划>14
算法
福兮说1 小时前
浏览器里把 iPhone 的 HEIC 转成 JPG:Chrome 解不开、转完大了七成、拍摄时间全丢,六个坑实测
前端·javascript·图像处理·chrome·ios·iphone·heic
libokaifa1 小时前
把语音模型塞进手机:sherpa-onnx 在 Android 上的 ASR / TTS
前端
时间的拾荒人1 小时前
Qt 界面美化实战:QSS 样式表
开发语言·qt·面试
赛博守夜人1 小时前
跨境业务与出海合规之九:海外买量投放与营销虚假流量(Ad Fraud):跨国机房群控与归因欺诈识别算法
算法·安全
deli0071 小时前
DLA 枝晶生长实测:5000 个粒子集体停摆之后,分形维数收敛到 1.70
前端